# The base path
export PATH=/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/usr/sbin:/sbin:$PATH

# The scripts path
export PATH=$DOTFILES/bin:$PATH
if [ -d "$HOME/.scripts" ]; then
    export PATH=$HOME/.scripts:$PATH
fi

if [ -d "$HOME/.config/dotfiles/bin-extra" ]; then
    export PATH=$HOME/.config/dotfiles/bin-extra:$PATH
fi

# Rust path
if [ -d $HOME/.cargo ]; then
    export PATH=$HOME/.cargo/bin:$PATH
    # Use sccache if available
    command -v sccache > /dev/null 2>&1

    if [ $? -eq 0 ]; then
        export RUSTC_WRAPPER=sccache
    fi
fi

# .local path
if [ -d $HOME/.local/bin ]; then
    export PATH=$HOME/.local/bin:$PATH
fi


# Wasmer path
if [ -d $HOME/.wasmer ]; then
    export WASMER_DIR="$HOME/.wasmer"
    export WASMER_CACHE_DIR="$WASMER_DIR/cache"
    export PATH="$WASMER_DIR/bin:$WASMER_DIR/globals/wapm_packages/.bin:$PATH"
fi

# Node path
if [ -d $HOME/.npmbin ]; then
    export PATH=$HOME/.npmbin/bin:$PATH
fi

# LD_LIBRARY_PATH: I don't know why there is this line here but I'm too scared
# to delete it
export LD_LIBRARY_PATH=/usr/lib:$LD_LIBRARY_PATH

# Texmf home: hidden directory
export TEXMFHOME=$HOME/.texmf

# My git directory: where I want to clone all my repos
export GCLONE_PATH=~/git
